import mongoose, { Schema } from "mongoose";
import IPost from "../interfaces/IPost";

const PostsSchema: Schema = new Schema<IPost>({
    title: {
        type: String,
        required: true
    },
    description: {
        type: String,
        required: false
    },
    image: String,
    datetime: {
        type: Date,
        default: Date.now()
    }
}, {
    versionKey: false
})

export const Post = mongoose.model<IPost>('Post', PostsSchema)